// ==========================================================================
// $Id: point2d.cpp,v 1.2 2014/10/22 20:33:26 jlang Exp $
// CSI2372 example Code for lecture 4
// ==========================================================================
// (C)opyright:
//
//   Jochen Lang
//   SITE, University of Ottawa
//   800 King Edward Ave.
//   Ottawa, On., K1N 6N5
//   Canada. 
//   http://www.site.uottawa.ca
// 
// Creator: jlang (Jochen Lang)
// Email:   jlang@site.uottawa.ca
// ==========================================================================
// $Log: point2d.cpp,v $
// Revision 1.2  2014/10/22 20:33:26  jlang
// changes for lecture
//
// Revision 1.1  2011/09/27 17:22:21  jlang
// Added bounding shape example
//
// Revision 1.1  2010/09/29 14:28:59  jlang
// Separate files for line_segment and point2d. Added test_point and make label test
//
// Revision 1.5  2008/10/15 21:31:32  jlang
// Reverting to 1.3
//
// Revision 1.3  2008/09/15 18:29:08  jlang
// Clarified comments
//
// Revision 1.2  2006/09/23 00:14:50  jlang
// Removed some pass by reference
//
// Revision 1.1  2006/09/23 00:00:55  jlang
// Added files for lecture 4
//
//
// ==========================================================================
#include "point2d.h"

/**
 * Point2D - All argument constructor
 */
Point2D::Point2D( double _x, double _y ) {
  d_x = _x;
  d_y = _y;
}

/**
 * Dot product between two "points"
 */
double Point2D::dot( Point2D _oPoint ) {
  double res = _oPoint.d_x * d_x + _oPoint.d_y * d_y;
  return res;
}

/**
 * Add a "point" to this point and return result 
 */
Point2D Point2D::add( Point2D _oPoint ) {
  Point2D res;
  res.d_x = d_x + _oPoint.d_x;
  res.d_y = d_y + _oPoint.d_y;
  return res;
}


/**
 * Subtract a "point" from this point and return result
 */
Point2D Point2D::subtract( Point2D _oPoint ) {
  Point2D res;
  res.d_x = d_x - _oPoint.d_x;
  res.d_y = d_y - _oPoint.d_y;
  return res;
}


