// ==========================================================================
// $Id: image_io.cpp,v 1.1 2011/12/05 17:25:20 jlang Exp $
// Main routine for binary image io
// ==========================================================================
// (C)opyright:
//
//   Jochen Lang
//   SITE, University of Ottawa
//   800 King Edward Ave.
//   Ottawa, On., K1N 6N5
//   Canada. 
//   http://www.site.uottawa.ca
// 
// Creator: jlang (Jochen Lang)
// Email:   jlang@site.uottawa.ca
// ==========================================================================
// $Log: image_io.cpp,v $
// Revision 1.1  2011/12/05 17:25:20  jlang
// Adapted pnm_image_io to lecture 14
//
//
// ==========================================================================
#include <iostream>
#include <string>
#include "pnm_image_io.h"
#include "pnm_image_io.cpp"


using std::cerr;
using std::endl;
using std::string;

int main() {
  int nRows, nCols;
  PNM_ImageIO<unsigned int,3> reader;

  string inFileName = "in.ppm";
  string outFileName = "out.ppm";

  unsigned char* data = reader.read( inFileName, nRows, nCols );
  if ( data == 0 ) {
    cerr << "Size is 0 in ppm ColorImage ( " 
	 << inFileName << " )" << endl;
    nRows = 0;
    nCols = 0;
  } 
  PNM_ImageIO<unsigned int,3> writer;
  writer.setBinary( true );
  bool result = writer.write( outFileName, data, nRows, nCols );

  return 0;
}
