// ==========================================================================
// $Id: matrix3d.h,v 1.1 2013/11/06 17:36:04 jlang Exp $
// CSI2372 example Code for lecture 12
// ==========================================================================
// (C)opyright:
//
//   Jochen Lang
//   SITE, University of Ottawa
//   800 King Edward Ave.
//   Ottawa, On., K1N 6N5
//   Canada. 
//   http://www.site.uottawa.ca
// 
// Creator: jlang (Jochen Lang)
// Email:   jlang@site.uottawa.ca
// ==========================================================================
// $Log: matrix3d.h,v $
// Revision 1.1  2013/11/06 17:36:04  jlang
// Matrix friendship without operators
//
// Revision 1.2  2006/11/20 21:34:07  jlang
// Added friend/inline/static demo
//
//
// ==========================================================================
#ifndef MATRIX_3D_
#define MATRIX_3D_

#include <iostream>
#include <cassert>

using std::ostream;
using std::endl;

class Vector3D;

class Matrix3D {
  double d_elements[9];
public:
  Matrix3D();
  Vector3D mul( Vector3D& );
  // inline short accessor functions
  inline double get(int _row, int _col) const;
  inline double& get(int _row, int _col);
  // grant friendship to insertion operator
  friend 
  ostream& operator<< ( ostream &os, const Matrix3D& _mat );
};


double Matrix3D::get(int _row, int _col) const {
  assert(_row >= 0 && _row<3);
  assert(_col >= 0 && _col<3);
  return d_elements[_row * 3 + _col];
}

double& Matrix3D::get(int _row, int _col) {
  assert(_row >= 0 && _row<3);
  assert(_col >= 0 && _col<3);
  return d_elements[_row * 3 + _col];
}

#endif

