// ==========================================================================
// $Id: vector3d.cpp,v 1.1 2013/11/06 17:36:04 jlang Exp $
// CSI2372 example Code for lecture 12
// ==========================================================================
// (C)opyright:
//
//   Jochen Lang
//   SITE, University of Ottawa
//   800 King Edward Ave.
//   Ottawa, On., K1N 6N5
//   Canada. 
//   http://www.site.uottawa.ca
// 
// Creator: jlang (Jochen Lang)
// Email:   jlang@site.uottawa.ca
// ==========================================================================
// $Log: vector3d.cpp,v $
// Revision 1.1  2013/11/06 17:36:04  jlang
// Matrix friendship without operators
//
// Revision 1.2  2006/11/20 21:34:07  jlang
// Added friend/inline/static demo
//
//
// ==========================================================================
#include <iostream>
#include <cmath>

#include "vector3d.h"


// Initialize non-constant, non-integral variables like this.
const double Vector3D::ZERO = 1E-99;


Vector3D::Vector3D( double _x, double _y, double _z ) 
{
  d_components[0] = _x;
  d_components[1] = _y;
  d_components[2] = _z;
} 

bool Vector3D::isNotZero() {
  for ( int i=0; i<3; ++i ) {
    if ( fabs(d_components[i]) > ZERO ) return false;
  }
  return true;
}


ostream& operator<< ( ostream &os, const Vector3D& _vec ) {
  os << "[";
  for ( int col=0; col<3; col++ ) {
    os << " " << _vec.d_components[col];
  }
  os << " ]^T " << endl;
  return os;
}
